wayland::server::subsurface_t(3)

NAME
wayland::server::subsurface_t - sub-surface interface to a wl_surface

SYNOPSIS

#include <wayland-server-protocol.hpp>

  Public Member Functions

std::function< void()> & on_destroy ()
remove sub-surface interface
std::function< void(int32_t, int32_t)> & on_set_position ()
reposition the sub-surface
std::function< void(surface_t)> & on_place_above ()
restack the sub-surface
std::function< void(surface_t)> & on_place_below ()
restack the sub-surface
std::function< void()> & on_set_sync ()
set sub-surface to synchronized mode
std::function< void()> & on_set_desync ()
set sub-surface to desynchronized mode
void post_bad_surface (std::string const &msg)
Post error: wl_surface is not a sibling or the parent.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

Detailed Description

sub-surface interface to a wl_surface

An additional interface to a wl_surface object, which has been made a sub-surface. A sub-surface has one parent surface. A sub-surface's size and position are not limited to that of the parent. Particularly, a sub-surface is not automatically clipped to its parent's area.

A sub-surface becomes mapped, when a non-NULL wl_buffer is applied and the parent surface is mapped. The order of which one happens first is irrelevant. A sub-surface is hidden if the parent becomes hidden, or if a NULL wl_buffer is applied. These rules apply recursively through the tree of surfaces.

The behaviour of a wl_surface.commit request on a sub-surface depends on the sub-surface's mode. The possible modes are synchronized and desynchronized, see methods wl_subsurface.set_sync and wl_subsurface.set_desync. Synchronized mode caches the wl_surface state to be applied when the parent's state gets applied, and desynchronized mode applies the pending wl_surface state directly. A sub-surface is initially in the synchronized mode.

Sub-surfaces also have another kind of state, which is managed by wl_subsurface requests, as opposed to wl_surface requests. This state includes the sub-surface position relative to the parent surface (wl_subsurface.set_position), and the stacking order of the parent and its sub-surfaces (wl_subsurface.place_above and .place_below). This state is applied when the parent surface's wl_surface state is applied, regardless of the sub-surface's mode. As the exception, set_sync and set_desync are effective immediately.

The main surface can be thought to be always in desynchronized mode, since it does not have a parent in the sub-surfaces sense.

Even if a sub-surface is in desynchronized mode, it will behave as in synchronized mode, if its parent surface behaves as in synchronized mode. This rule is applied recursively throughout the tree of surfaces. This means, that one can set a sub-surface into synchronized mode, and then assume that all its child and grand-child sub-surfaces are synchronized, too, without explicitly setting them.

If the wl_surface associated with the wl_subsurface is destroyed, the wl_subsurface object becomes inert. Note, that destroying either object takes effect immediately. If you need to synchronize the removal of a sub-surface to the parent surface update, unmap the sub-surface first by attaching a NULL wl_buffer, update parent, and then destroy the sub-surface.

If the parent wl_surface object is destroyed, the sub-surface is unmapped.

Definition at line 4259 of file wayland-server-protocol.hpp.

Member Function Documentation

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  std::function< void()> & subsurface_t::on_destroy ()

remove sub-surface interface The sub-surface interface is removed from the wl_surface object that was turned into a sub-surface with a wl_subcompositor.get_subsurface request. The wl_surface's association to the parent is deleted, and the wl_surface loses its role as a sub-surface. The wl_surface is unmapped immediately.

Definition at line 3149 of file wayland-server-protocol.cpp.

  std::function< void(surface_t)> & subsurface_t::on_place_above ()

restack the sub-surface

Parameters
    sibling the reference surface

This sub-surface is taken from the stack, and put back just above the reference surface, changing the z-order of the sub-surfaces. The reference surface must be one of the sibling surfaces, or the parent surface. Using any other surface, including this sub-surface, will cause a protocol error.

The z-order is double-buffered. Requests are handled in order and applied immediately to a pending state. The final pending state is copied to the active state the next time the state of the parent surface is applied. When this happens depends on whether the parent surface is in synchronized mode or not. See wl_subsurface.set_sync and wl_subsurface.set_desync for details.

A new sub-surface is initially added as the top-most in the stack of its siblings and parent.

Definition at line 3161 of file wayland-server-protocol.cpp.

  std::function< void(surface_t)> & subsurface_t::on_place_below ()

restack the sub-surface

Parameters
    sibling the reference surface

The sub-surface is placed just below the reference surface. See wl_subsurface.place_above.

Definition at line 3167 of file wayland-server-protocol.cpp.

  std::function< void()> & subsurface_t::on_set_desync ()

set sub-surface to desynchronized mode Change the commit behaviour of the sub-surface to desynchronized mode, also described as independent or freely running mode.

In desynchronized mode, wl_surface.commit on a sub-surface will apply the pending state directly, without caching, as happens normally with a wl_surface. Calling wl_surface.commit on the parent surface has no effect on the sub-surface's wl_surface state. This mode allows a sub-surface to be updated on its own.

If cached state exists when wl_surface.commit is called in desynchronized mode, the pending state is added to the cached state, and applied as a whole. This invalidates the cache.

Note: even if a sub-surface is set to desynchronized, a parent sub-surface may override it to behave as synchronized. For details, see wl_subsurface.

If a surface's parent surface behaves as desynchronized, then the cached state is applied on set_desync.

Definition at line 3179 of file wayland-server-protocol.cpp.

  std::function< void(int32_t, int32_t)> & subsurface_t::on_set_position ()

reposition the sub-surface

Parameters
    x x coordinate in the parent surface
    y y coordinate in the parent surface

This schedules a sub-surface position change. The sub-surface will be moved so that its origin (top left corner pixel) will be at the location x, y of the parent surface coordinate system. The coordinates are not restricted to the parent surface area. Negative values are allowed.

The scheduled coordinates will take effect whenever the state of the parent surface is applied. When this happens depends on whether the parent surface is in synchronized mode or not. See wl_subsurface.set_sync and wl_subsurface.set_desync for details.

If more than one set_position request is invoked by the client before the commit of the parent surface, the position of a new request always replaces the scheduled position from any previous request.

The initial position is 0, 0.

Definition at line 3155 of file wayland-server-protocol.cpp.

  std::function< void()> & subsurface_t::on_set_sync ()

set sub-surface to synchronized mode Change the commit behaviour of the sub-surface to synchronized mode, also described as the parent dependent mode.

In synchronized mode, wl_surface.commit on a sub-surface will accumulate the committed state in a cache, but the state will not be applied and hence will not change the compositor output. The cached state is applied to the sub-surface immediately after the parent surface's state is applied. This ensures atomic updates of the parent and all its synchronized sub-surfaces. Applying the cached state will invalidate the cache, so further parent surface commits do not (re-)apply old state.

See wl_subsurface for the recursive effect of this mode.

Definition at line 3173 of file wayland-server-protocol.cpp.

  void subsurface_t::post_bad_surface (std::string const & msg)

Post error: wl_surface is not a sibling or the parent.

Definition at line 3185 of file wayland-server-protocol.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

Author

Generated automatically by Doxygen for Wayland++ from the source code.